package cordon.bleu.user;


import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import javax.validation.constraints.Email;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;

@Entity
@Getter
@Setter
@Table(name = "users")
public class User {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private int id;


    @NotBlank(message = "{user.email}")
    @Email(message = "{user.email}")
    private String email;

    @Size(min = 2, message = "{user.firstname}")
    private String firstName;

    @Size(min = 2, message = "{user.lastname}")
    private String lastName;

    private String passWord;

    private Boolean enabled;


    @OneToOne(cascade = CascadeType.ALL, mappedBy = "user")
    private UserRole userRole;

}
